<?php

// 01. URL de l'environnement à appeler (TEST ou PRODUCTION)
define('API_ENDPOINT', 'https://stage-secure2-vault.hipay-tpp.com/rest/v2/token'); // TEST
// define('API_ENDPOINT', 'https://secure-gateway.hipay-tpp.com/rest/v1'); // PRODUCTION


// 02. Identifiant API du compte HiPay pour s'authentifier auprès de l'API HiPay
define('API_USERNAME', '94679151.stage-secure-gateway.hipay-tpp.com');
define('API_PASSWORD', 'Test_XfBilqDSBZJfUqvrQVyjFxD3');


// 03. Création des 2 variables pour stocker les infos sur l'environnement, l'API et les identifiants API
$resource = API_ENDPOINT;
$credentials = API_USERNAME . ':' . API_PASSWORD;



// 04. Construction de la requête
$request = array(
// 1. Design et paramétrage de la page
'card_number'=>'4000000000000002',
'card_expiry_month'=>'12',
'card_expiry_year'=>'2025',
'card_holder'=>'Cathy Doe',
'cvc'=>'123',
'multi_use'=>'0'
	);


// 05. Initialisation de cURL
$curl = curl_init();

// 07. Définition des en-têtes
$header = array(
  'User-Agent: ' .$_SERVER['HTTP_USER_AGENT'],
  'Accept: application/json',
  'Accept-Language: ' . $_SERVER['HTTP_ACCEPT_LANGUAGE']
);

// 07. Configuration des options de cURL
$options = array(
	CURLOPT_URL => $resource,
	CURLOPT_USERPWD => $credentials,
	CURLOPT_HTTPHEADER => $header,
	CURLOPT_RETURNTRANSFER =>true,
	CURLOPT_FAILONERROR => false,
	CURLOPT_HEADER =>false,
	CURLOPT_POST => true,
	CURLOPT_POSTFIELDS => $request
);


foreach ($options as $option => $value) {
	curl_setopt($curl, $option, $value);
}

// 08. Exécution de cURL
if (false === ($result = curl_exec($curl))) {
	echo "<br/><strong>Error: </strong><br/>";
	var_dump(curl_error($curl), curl_errno($curl));
	exit();
}

$status = (int)curl_getinfo($curl, CURLINFO_HTTP_CODE);

// 09. Affichage de la réponse API
$response = json_decode($result);
var_dump($response);

$token = $response->token;
$pan = $response->pan;
//$captured = $response->capturedAmount;
//$refounded = $response->refundedAmount;


 // 10. Deconnexion de cURL
curl_close($curl);

// 11. Afficher les infos de la réponse
echo 'token : '.$token.'<br />PAN : '.$pan.'<br />Montant déjà capturé : '.$token;
?>


